Prime Path POJ - 3126
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
bfs求最短路径问题。分别更改四位数的每一位,然后判断是否为素数,若是, 则入队。
#include<iostream>
#include<cmath>
#include<cstring>
#include<queue>
#include<set>
using namespace std;
int n;
int x,y,ans;
bool vis[10010];
set<int>prime;
struct node{
int num;
int step;
};
int isprime(int x)//判断是否为素数
{
if(x==2||x==3)
return 1;
if(x%6!=5&&x%6!=1)
return 0;
int i,j;
for(i=5;i<=sqrt(x);i+=6)
{
if(x%i==0||x%(i+2)==0)
{
return 0;
}
}
return 1;
}
int judge(int s)
{
if(prime.find(s)==prime.end())
{
return false;
}
if(vis[s])
{
return false;
}
return true;
}
void bfs()
{
queue<node>q;
node cur,next;
cur.num=x;
cur.step=0;
q.push(cur);
vis[x]=true;
while(!q.empty())
{
cur=q.front();
q.pop();
int j,i,nx;
if(cur.num==y)
{
ans=cur.step;
return;
}
set<int>::iterator it=prime.begin();//迭代器
for(i=1000;i<=9000;i+=1000)//千位
{
nx=i+cur.num%1000;
if(judge(nx))
{
vis[nx]=true;
next.num=nx;
next.step=cur.step+1;
q.push(next);
}
}
for(i=0;i<=9;i++)//百位
{
nx=cur.num/1000*1000+cur.num%100+i*100;
if(judge(nx))
{
vis[nx]=true;
next.num=nx;
next.step=cur.step+1;
q.push(next);
}
}
for(i=0;i<10;i++)//十位
{
nx=cur.num/100*100+cur.num%10+i*10;
if(judge(nx))
{
vis[nx]=true;
next.num=nx;
next.step=cur.step+1;
q.push(next);
}
}
for(i=0;i<10;i++)//个位
{
nx=cur.num/10*10+i;
if(judge(nx))
{
vis[nx]=true;
next.num=nx;
next.step=cur.step+1;
q.push(next);
}
}
}
}
int main()
{
int i,k=0;
for(i=1000;i<=9999;i++)
{
if(isprime(i))
{
prime.insert(i);//素数打表
}
}
int t;
cin>>t;
while(t--)
{
memset(vis,0,sizeof(vis));
ans=0;
cin>>x>>y;
bfs();
if(ans)
{
cout<<ans<<endl;
}
else
{
cout<<0<<endl;
}
}
return 0;
}